
mode quiet

%path = @runpath
cd %path

load data_usa

' create yearly pages 
%startdate="1900"	'"1892"
%enddate="2013"	'"2014"

'

Wfcreate(wf=analysis_usa,page="") y %startdate %enddate

copy(c=na) data_usa::yearly\r
copy(c=na) data_usa::yearly\m1rsy_new

wfclose data_usa


'*************************************************************************************
' UR test 
series log_m1rsy=log(m1rsy_new)
series log_r=log(r)
for %j m1rsy  r 
freeze(ur_log_{%j}) log_{%j}.uroot(np,hac=argls,info=maic,maxlag=12) 
next


'*************************************************************************************
'Estimate the break dates via the Eviews algorithm

for !ll=4 to 4 step 1
group dols{!ll}
for %j r
for !i=-{!ll} to {!ll} step 1
group dols{!ll} dols{!ll} dlog({%j}(!i))
next
next
next


for !ll=4 to 4 step 1
equation eq_m1rsy_r_mbreaks{!ll}.ls log(m1rsy_new) c log(r) dols{!ll}
for %eps 15 20
if %eps="15" then 
!maxb=5
else if %eps="20" then
!maxb=3
endif
endif
freeze(globbrk_m1rsy_r_ll{!ll}_e{%eps}) eq_m1rsy_r_mbreaks{!ll}.multibreak(method=glob,trim={%eps},maxbreaks={!maxb}) c log(r)
freeze(infobrk_m1rsy_r_ll{!ll}_e{%eps}) eq_m1rsy_r_mbreaks{!ll}.multibreak(method=globinfo,trim={%eps},maxbreaks={!maxb}) c log(r)
next
next
delete eq_m1rsy_r_mbreaks4





'% Create dummy variables for structural breaks regression
smpl @all
series bini_44=0
series b45_75=0
series b76_end=0

smpl @first 1944
series bini_44=1
smpl 1945 1975
series b45_75=1
smpl 1976 @last
series b76_end=1


smpl @all
equation eq_nobreaks.ls(COV=HAC,COVKERN=BART,COVBW=NEWEYWEST,COVBWINT) LOG(M1RSY_new) c LOG(R) dols4

eq_nobreaks.makeresids res1_LL_m1rsyr



smpl @all
equation eq_breaks.ls(COV=HAC,COVKERN=BART,COVBW=NEWEYWEST,COVBWINT) LOG(M1RSY_new) BINI_44 B45_75 B76_END LOG(R)*BINI_44 LOG(R)*B45_75 LOG(R)*B76_END dols4

eq_breaks.makeresids res2_LL_m1rsyr


