function [break_dates,ftest,udmax,bic,lwz]=break_tests3(break_dates,bigt,y,zb,zf,db,df,m,h,eps1,ll,b,f,qb,qf,pb,pf,dotesting,fixb,eps,maxi,betaini,year)

if dotesting==1
   lrvar=zeros(m,1);
   supff=zeros(m,1);
   %break_dates=zeros(m,m);

   tic;
   for k=1:m
       %multiWaitbar('Break',k/m);
       [ftest,Omega,datevec]=wald(break_dates,y,zb,zf,db,df,k,bigt,ll,b,f,qb,qf,pb,pf,eps1,h,m,fixb,maxi,betaini,eps,year);
       supff(k,1)=ftest;
       lrvar(k,1)=Omega;
       %break_dates(1:k,k)=datevec;      
   end
   toc;

   udmax=max(supff);
   ftest=supff;
   %multiWaitbar('Break','Reset');

%Information criteria
   % Build DOLS regression
   w1=[];
   if ll>0
      z=[zb zf];
      dz=[zeros(1,size(z,2));z(2:end,:)-z(1:end-1,:)];
      w1=dz;
      for lf=1:1:ll
          w1=[w1 [zeros(lf,size(dz,2));dz(1:end-lf,:)]];  %lags
          w1=[w1 [dz(1+lf:end,:);zeros(lf,size(dz,2))]];  %leads   
      end
   end

   y1=y(ll+2:end-ll);
   z1b=[zb(ll+2:end-ll,:) db(ll+2:end-ll,:)];
   if size([zf df],2)>0
      z1f=[zf(ll+2:end-ll,:) df(ll+2:end-ll,:)];
   else
      z1f=[];
   end
   if ll>0
      w1=w1(ll+2:end-ll,:);
   end

   j=size(y1,1);
   
   [globl,~,~]=nldat(y1,z1b,[z1f w1],h,m,f,b,j,fixb,eps,maxi,betaini);

   zz=[z1b z1f w1];
   
   delta=(zz'*zz)\(zz'*y1);
   ssrzero=(y1-zz*delta)'*(y1-zz*delta);

   %[bic,lwz]=order(ssrzero,globl,bigt,m,b,f);
   [bic,lwz]=order(ssrzero,globl,length(y1),m,b,f);

end

%multiWaitbar('Break','Close');

end



function [ftest,Omega,datevecg]=wald(break_dates,y,zb,zf,db,df,g,bigt,ll,b,f,qb,qf,pb,pf,eps1,h,m,fixb,maxi,betaini,eps,year)

% Build DOLS regression
w1=[];
if ll>0
   z=[zb zf];
   dz=[NaN(1,size(z,2));z(2:end,:)-z(1:end-1,:)];
   w1=dz;
   for lf=1:1:ll
       w1=[w1 [NaN(lf,size(dz,2));dz(1:end-lf,:)]];  %lags
       w1=[w1 [dz(1+lf:end,:);NaN(lf,size(dz,2))]];  %leads   
   end
end

break_dates=break_dates';
zbar=pzbar([zb db],g,break_dates(1:g,g));
y1=y(ll+2:end-ll);
z1b=[zb(ll+2:end-ll,:) db(ll+2:end-ll,:)];
zbar=zbar(ll+2:end-ll,:);
if size([zf df],2)>0
   z1f=[zf(ll+2:end-ll,:) df(ll+2:end-ll,:)];
else
   z1f=[];
end
if ll>0
   w1=w1(ll+2:end-ll,:);
end

tt=size(y1,1);
%year=year(ll+2:end-ll);
wbar=[zbar z1f w1];
w=[z1b z1f w1];
gammahat=(wbar'*wbar)\(wbar'*y1);
deltahat=(w'*w)\(w'*y1);
ssrk=(y1-wbar*gammahat)'*(y1-wbar*gammahat);
ssr0=(y1-w*deltahat)'*(y1-w*deltahat);
uhat=y1-wbar*gammahat;
uhatnull=y1-w*deltahat;
[Omega,Sigma]=lrv(uhat,uhatnull,bigt,ll);
ftest=(ssr0-ssrk)/(g*Omega);
fprintf('ftest = %10.4f\n',ftest);

datevecg=year(break_dates(1:g,g));

end




function [Omega,Sigma]=lrv(uhat,uhatnull,bigt,ll)

u=uhat;
e = u;
te = bigt-(ll*2+1);
eb = e(1:te-1,:);
ef = e(2:te,:);
ae=(eb'*eb)\(eb'*ef);
ee=zeros(te-1,1);
ee(:,1)=ef(:,1)-eb(:,1)*ae;
se=sqrt(inv(te-1)*ee(:,1)'*ee(:,1));
ad=((se)^2)/(1-ae)^4;
a2=(4*(ae*se/(1-ae)^4)^2/ad);                              
eband = 1.3221*((a2*te)^.2);

jb = (1:1:te-1)'/eband;                              
jband = jb*1.2*pi;
kern = ((sin(jband)./jband - cos(jband))./(jband.^2)).*3;
sig = uhatnull'*uhatnull;
lam = 0;
for j=1:1:te-1
    lam = lam + (uhatnull(1:te-j,:)'*uhatnull(1+j:te,:))*kern(j);
end
%delta = sig+lam;
omega = sig+lam+lam';
omega(1,1)=omega(1,1)/te;

Omega=omega(1,1);
Sigma=sig/te;

end





function [globl,datevec,bigvec]=nldat(y,z,x,h,m,p,q,bigt,fixb,eps,maxi,betaini)
globl=zeros(m,1);
datevec=zeros(m,m);
%datenl=zeros(m,m);

for mi=1:1:m;

    if p>0
       if fixb == 0
% @******************************************************************@
% /*Segment to initialize the beta vector. We apply treat the model
% as one of pure structural change and apply the dynamic programming
% algorithm to get the break dates.
% */
          zz=[x z];

          [~,datenl,bigvec]=dating(y,zz,h,mi,bigt);

          xbar=pzbar(x,mi,datenl(1:mi,mi));
          zbar=pzbar(z,mi,datenl(1:mi,mi));
          teta=([zbar xbar]'*[zbar xbar])\([zbar xbar]'*y);
          delta1=teta(1:q*(mi+1),1);
          beta1=(x'*x)\(x'*(y-zbar*delta1));

% Calculate SRR.
          ssr1=(y-x*beta1-zbar*delta1)'*(y-x*beta1-zbar*delta1);

% @******************************************************************@
       else
       
% if fix = 1, the initial value of beta is fixed. We initialize
% SSR at some negative number to start the iterations*/

          beta1=betaini;
          ssr1=-5;

       end
%@*****************************************************************@

% Starting the iterations. */
% if printd == 1;
% print "Output from the iterations";
% else;
% endif;

       length=99999999.0;
       i=1;
       while length > eps

             [~,datenl,bigvec]=dating((y-x*beta1),z,h,mi,bigt);

             zbar=pzbar(z,mi,datenl(1:mi,mi));
             teta1=([x zbar]'*[x zbar])\([x zbar]'*y);
             beta1=teta1(1:p,1);
             %delta1=teta1(p+1:p+q*(mi+1),1);
             ssrn=(y-([x zbar])*teta1)'*(y-([x zbar])*teta1);

% Calculate overall SRR and check if significantly smaller.

             length=abs(ssrn-ssr1);

             if i <= maxi
                i=i+1;
                ssr1=ssrn;
                globl(mi,1)=ssrn;
                datevec(1:mi,mi)=datenl(1:mi,mi);
             else
                disp('The number of iterations has reached the upper limit')
                length=0;
             end
       end

    elseif p==0;
          
           [~,datenl,bigvec]=dating(y,z,h,mi,bigt);

           zbar=pzbar(z,mi,datenl(1:mi,mi));
           teta1=(zbar'*zbar)\(zbar'*y);
           ssrn=(y-(zbar)*teta1)'*(y-(zbar)*teta1);

           globl(mi,1)=ssrn;
           datevec(1:mi,mi)=datenl(1:mi,mi);
    end

end

end



function [globl,datevec,bigvec]=dating(y,z,h,m,bigt)

% @This is the main procedure which calculates the break points that
% globally minimizes the SSR. It returns optimal dates and associated SSR
% for all numbers of breaks less than or equal to m.@

datevec=zeros(m,m);
optdat=zeros(bigt,m);
optssr=zeros(bigt,m);
dvec=zeros(bigt,1);
globl=zeros(m,1);

bigvec=zeros(bigt*(bigt+1)/2,1);

%segment to construct the vector of SSR of dimension T*(T+1)/2

for i=1:1:(bigt-h+1)
    vecssr=ssr(i,y,z,h,bigt);
    bigvec((i-1)*bigt+i-(i-1)*i/2:i*bigt-(i-1)*i/2,1)=vecssr(i:bigt,1);
end


% Section that applies the dynamic programming algorithm to look for the
% optimal breaks
% The first case is when m = 1. Here the dynamic programming algorithm is not
% needed and one call to the parti(.) procedure is enough.

if m == 1
   [ssrmin,datx]=parti(1,h,bigt-h,bigt,bigvec,bigt);
   datevec(1,1)=datx;
   globl(1,1)=ssrmin;
else

%   when m > 1, a dynamic programming algorithm is used.
%   The first step is to obtain the optimal one break partitions for all
%   possible ending dates from 2h to T-mh+1.
%   The optimal dates are stored in a vector optdat.
%   The associated ssr are stored in a vector optssr.

   for j1=2*h:1:bigt                               %First loop. Looking for the optimal one break partitions@
       [ssrmin,datx]=parti(1,h,j1-h,j1,bigvec,bigt);   %for break dates between h and@
       optssr(j1,1)=ssrmin;                            %T-h. j1 is the last date of the@
       optdat(j1,1)=datx;                              %segments.@
   end

   globl(1,1)=optssr(bigt,1);
   datevec(1,1)=optdat(bigt,1);

% When this is done the algorithm looks for optimal 2,3,... breaks
% partitions. The index used is ib.

   for ib=2:1:m
       if ib == m               %if we have reached the highest number of breaks
                             %considered, only one segment is considered, that
                             %which ends at the last date of the sample.@
          jlast=bigt;
          for jb=ib*h:1:jlast-h    %date of the break */
              dvec(jb,1) = optssr(jb,ib-1)+bigvec((jb+1)*bigt-jb*(jb+1)/2,1);
          end
          [optssr(jlast,ib),I]=min(dvec(ib*h:jlast-h,1));
          optdat(jlast,ib)=(ib*h-1)+I;

       else
                           %if we have not reached the highest number of breaks
                           %considered, we need to loop over the last date of
                           %the segment, between (ib+1)*h and T.@
          for jlast=(ib+1)*h:1:bigt

              for jb=ib*h:1:jlast-h           %date of the break */
                  dvec(jb,1) = optssr(jb,ib-1)+bigvec(jb*bigt-jb*(jb-1)/2+jlast-jb,1);
              end
        
              [optssr(jlast,ib),II]=min(dvec(ib*h:jlast-h,1));
              optdat(jlast,ib)=(ib*h-1)+II;
          end
       end

%At each time we loop the results with ib breaks are retrieved and printed@

       datevec(ib,ib)=optdat(bigt,ib);

       for i=1:1:ib-1
           xx=ib-i;
           datevec(xx,ib)=optdat(datevec(xx+1,ib),xx);
       end
       globl(ib,1)=optssr(bigt,ib);

   end
   
end                           %closing the if for the case m >1*/

%clear bigvec

end




function vecssr=ssr(start,y,z,h,last)

% This procedure computes recursive residuals from a data set that
% starts at date "start" and ends at date "last". It returns a
% vector of sum of squared residuals (SSR) of length last-start+1 (stored for
% convenience in a vector of length T).

% start: starting entry of the sample used.
% last: ending date of the last segment considered
% y: dependent variable
% z: matrix of regressors of dimension q
% h: minimal length of a segment

% initialize the vectors */
vecssr=zeros(last,1);

% initialize the recursion with the first h data points */

inv1=inv(z(start:start+h-1,:)'*z(start:start+h-1,:));
%delta1=inv1*(z(start:start+h-1,:)'*y(start:start+h-1,1));
delta1=(z(start:start+h-1,:)'*z(start:start+h-1,:))\(z(start:start+h-1,:)'*y(start:start+h-1,1));
res=y(start:start+h-1,1)-z(start:start+h-1,:)*delta1;
vecssr(start+h-1,1)=res'*res;

% loop to construct the recursive residuals and update the SSR */

for r=start+h:1:last
    v=y(r,1)-z(r,:)*delta1;
    invz=inv1*z(r,:)';
    f=1+z(r,:)*invz;
    delta2=delta1+(invz*v)/f;
    inv2=inv1-(invz*invz')/f;
    inv1=inv2;
    delta1=delta2;
    vecssr(r,1)=vecssr(r-1,1)+v*v/f;
end

end





function [ssrmin,dx]=parti(start,b1,b2,last,bigvec,bigt)

% procedure to obtain an optimal one break partitions for a segment that
% starts at date start and ends at date last. It return the optimal break
% and the associated SSR.
% 
% start: begining of the segment considered
% b1: first possible break date
% b2: last possible break date
% last: end of segment considered

dvec=zeros(bigt,1);
ini=(start-1)*bigt-(start-2)*(start-1)/2+1;

for j=b1:1:b2
    jj=j-start;
    k=j*bigt-(j-1)*j/2+last-j;
    dvec(j,1)=bigvec(ini+jj,1)+bigvec(k,1);
end
[ssrmin,I]=min(dvec(b1:b2,1));
dx=(b1-1)+I;
end




function zb=pzbar(zz,m,bb)

%procedure to construct the diagonal partition of z with m break at dates b.@

[nt,q1]=size(zz);

zb=zeros(nt,(m+1)*q1);
zb(1:bb(1,1),1:q1)=zz(1:bb(1,1),:);
for i=2:1:m
    zb(bb(i-1,1)+1:bb(i,1),(i-1)*q1+1:i*q1)=zz(bb(i-1,1)+1:bb(i,1),:);
end
zb(bb(m,1)+1:nt,m*q1+1:(m+1)*q1)=zz(bb(m,1)+1:nt,:);
end




function [mbic,mlwz]=order(ssrzero,globl,bigt,m,q,p)

%Determination of the order using BIC and the criterion of Liu, Wu and Zidek.

glob=zeros(m+1,1);
glob(1,1)=ssrzero;
glob(2:m+1,1)=globl;

bic=zeros(m+1,1);
lwz=zeros(m+1,1);
for i=0:1:m
    bic(i+1,1)=log(glob(i+1,1)/bigt)+log(bigt)*((i+1)*q+i+p)/bigt;
    lwz(i+1,1)=log(glob(i+1,1)/(bigt-(i+1)*q-i-p))+(((i+1)*q+i+p)*.299*(log(bigt))^2.1)/bigt;
end
[~,mbic]=min(bic);
[~,mlwz]=min(lwz);

mbic=mbic-1;
mlwz=mlwz-1;
end


