function [eta,lrv]=cs(e)

T=size(e,1);

% ESTIMATING BANDWIDTH
ae=(e(1:T-1)'*e(1:T-1))\(e(1:T-1)'*e(2:T));         % AR(1) estimate
ee=e(2:T)-e(1:T-1)*ae;
te=size(ee,1);
%a1=4*(ae^2)/((1+ae)^2*(1-ae)^2);
%a2=4*(ae^2)/((1-ae)^4);

% Bartlett Kernel with Kurozumi correction
k=0.8;
arg=[1.1447*((4*(ae^2)*te)/(((1+ae)^2)*((1-ae)^2)))^(1/3);1.1447*((4*(k^2)*te)/(((1+k)^2)*((1-k)^2)))^(1/3)];
Kband=min(arg);
Kband = floor(Kband);      %Truncate the estimated bandwidth @
l=Kband;
% Short-run variance
lrv=(e'*e)/T;              
% Long-run variance
for i=1:1:l 
	w=(1-i/(l+1));         %Bartlett kernel
 	lrv=lrv+2*e(1:T-i)'*e(1+i:T)*w/T; 
end

S = cumsum(e);
eta=inv((T^2)*lrv)*(S'*S);%sum(cumsum(e).^2);

end